/*
    Gamma.java
    Copyright (C) 2008 David Clausen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// compute the gamma tables used in ledcyl.c
// gamma of 1.5 seems about right.  use a max of 4095 for normal
// use.  however if you want to take pictures of the cylinder,
// it helps to reduce the brightness by a factor of 10x, otherwise
// the camera gets overloaded.. specify max=400 in that case.

import java.util.*;

public class Gamma {

    // usage: java Gamma GAMMA (<MAX>)
    // e.g. "java Gamma 1.5"
    //      "java Gamma 1.5 400"
    public static void main(String[] args) throws Exception {
	double gamma = Double.parseDouble(args[0]);
	double max = (args.length == 1) ? 4095 : Integer.parseInt(args[1]);
	double scale = max / Math.pow(255, gamma);
	for (int i = 0; i < 256; i++) {
	    System.out.print(Math.round((scale * Math.pow(i, gamma))));
	    System.out.print(",");
	    if ((i % 16) == 15) {
		System.out.println();
	    }
	}
    }

}